unit SakEmail;
{

    SakEmail components Version 1.10.0 final
    Copyright  1997, 1998, 1999 Sak
    Sergio Kessler
    email: sergio@perio.unlp.edu.ar
    web: http://www.perio.unlp.edu.ar/~sergio


        Well, I developed this components because I hate OCX's (NetManage's
        very included).

        So, I decided to develop my own components (my first components -Wow !)
        and release it under the Library GNU public licensee (LGPL).

        Thanks also to Tony BenBrahim for his base64 routines (wich I modified
        a bit to fit in this project), because the mines are too slow.
	Also I ripped the UUDecode alghoritm, I don't know the author.

        And thanks to all the Delphi community.
        What marvelous people ! (like the product)

Legal stuff:

  See Copying file.
}

interface

uses Windows, SysUtils, Classes, Forms, scktcomp, sak_util;

{$IFDEF VER100}
{$DEFINE DELPHI3}
{$ENDIF}

type

  TSessionState = ( Authorization, Transaction);
  TOnError = procedure(Sender: TObject; Error: integer; Msg: string) of object;
  TOnReadEvent = procedure( Sender: TObject; BytesRead: integer) of object;
  TOnCodeStartEvent = procedure( Sender: TObject; FileName: string; BytesCount: longint) of object;
  TOnCodeProgressEvent = procedure( Sender: TObject; Percent: word) of object;
  TOnSendProgressEvent = procedure( Sender: TObject; Percent: word) of object;
  TOnDeleteEvent = procedure( Sender: TObject; id: word) of object;
  TOnBeforeRetrieve = procedure( sender: TObject; id: word) of object;

  TSakMsg = class;

  TAttachedFile  = class( TCollectionItem)
  private
    FFileName: string;
    FUNCFileName: string;
    FBodyEncoded: TStringList;
    FBodyBin: TMemoryStream;
    FMIMEType: string;
  protected
  public
    constructor Create( Collection: TCollection); override;
    destructor Destroy; override;
    procedure SaveToFile( fn: string);
    procedure SaveToStream( Stream: TStream);
    property FileName: string read FFileName write FFileName;
    property FileStream: TMemoryStream read FBodyBin write FBodyBin;
    property MIMEType: string read FMIMEType;
  end;

  TAttachedFiles = class( TCollection)
  private
    FSakMsg: TSakMsg;
    function GetItem( index: integer): TAttachedFile;
    procedure SetItem( index: integer; value: TAttachedFile);
  public
    constructor Create( SakMsg: TSakMsg);
    function Add( fn: string): TAttachedFile;
    property Items[ index: integer]: TAttachedFile read GetItem write SetItem; default;
  end;

    // Priority //
  TPriority = (prHighest, prHigh, prNormal, prLow, prLowest);

{=============== SakMsg ===============}

  TSakMsg = class(TComponent)
  private
    { Private declarations }
    FPriority: TPriority;
    FUserName: string;
    FFrom: string;
    FMessageId: string;
    FInReplyTo: string;
    FReturnPath: string;
    FReplyTo: string;
    FSendTo: string;
    FCC: string;
    FBCC: string;
    FDate: string;
    FSubject: string;
    FText: TStringList;
    FExtraHeaders: TStringList; {Craig}
    FAttachedFiles: TAttachedFiles;
    FContentType: string;
    FContentTransferEncoding: string;
    FHeaders: TStringList;
    FCharSet: string;
    procedure SetText(Value: TStringList); {asem}
    procedure SetExtraHeaders(Value: TStringList); {Craig}
  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    destructor Destroy; override;
    property AttachedFiles: TAttachedFiles read FAttachedFiles write FAttachedFiles;
    property Date: string read FDate write FDate;
    property MessageId: string read FMessageId write FMessageId;
    property InReplyTo: string read FInReplyTo write FInReplyTo;
    property ReturnPath: string read FReturnPath write FReturnPath;
    property ContentType: string read FContentType; // Added by Kaufman Alex
    property ContentTransferEncoding: string read FContentTransferEncoding;
    property Headers: TStringList read FHeaders;    // Added by Kaufman Alex
  published
    { Published declarations }
    property UserName: string read FUserName write FUserName;
    property From: string read FFrom write FFrom;
    property ReplyTo: string read FReplyTo write FReplyTo;
    property SendTo: string read FSendTo write FSendTo;
    property CC: string read FCC write FCC;
    property BCC: string read FBCC write FBCC;
    property Subject: string read FSubject write FSubject;
    property Text: TStringList read FText write SetText; {asem}
    property ExtraHeaders: TStringList read FExtraHeaders write SetExtraHeaders; {Craig}
    // GN New Priority property //
    property Priority: TPriority read FPriority write FPriority default prNormal;
    property CharSet: string read FCharSet write FCharSet;
    // by Bob Dane
    procedure SaveToFile(fn: String);
  end;


{=============== SakMsgList ===============}

  TSakMsgList = class(TComponent)
  private
    { Private declarations }
    Flist: TList;
    function GetCount: integer;
  protected
    { Protected declarations }
    function  Get(Index: Integer): TsakMsg;
    procedure Put(Index: Integer; Item: TsakMsg);
  public
    { Public declarations }
    constructor Create( AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Clear;
    function  Add(Item: TsakMsg): Integer;
    procedure Delete(Index: Integer);
    function  First: TsakMsg;
    function  IndexOf(Item: TsakMsg): Integer;
    procedure Insert(Index: Integer; Item: TsakMsg);
    function  Last: TsakMsg;
    function  Remove(Item: TsakMsg): Integer;
    property  Items[ index: integer]: TSakMsg read Get write Put; default;
    property  Count: integer read GetCount;
    // by Bob Dane
    procedure SaveToFile(fn: String);
  end;


{=============== SakSMTP ===============}

  TSakSMTP = class(TComponent)
  private
    { Private declarations }
    FSocket: TClientSocket;
    FSocketStream: TWinSocketStream;

    FPort: string;
    FHost: String;
    FLocalizedDates: boolean;
    FSMTPError: boolean;
    FConnected: boolean;
    FReplyCode: string;
    FReplyString: string;
    FSendProgress: word;
    FSendProgressStep: word;
    FEncodeProgress: word;
    FEncodeProgressStep: word;
    FCanceled: boolean;

    FOnConnect: TNotifyEvent;
    FOnDisconnect: TNotifyEvent;
    FOnBeforeSend: TNotifyEvent;
    FOnAfterSend: TNotifyEvent;
    FOnError: TOnError;
    FOnSendProgress: TOnSendProgressEvent;
    FOnEncodeStart: TOnCodeStartEvent;
    FOnEncodeProgress: TOnCodeProgressEvent;
    FOnEncodeEnd: TNotifyEvent;

    procedure FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoError( Sender: TObject; Socket: TCustomWinSocket;
                        ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FDoErr( ErrorEvent: TErrorEvent);
    procedure FDoEncodeStart( FileName: string; Size: longint);
    procedure FDoEncodeProgress( Percent: word);
    procedure FDoEncodeEnd;
    procedure FDoSendProgress( Percent: word);
    procedure DoOnBeforeSend;
    procedure DoOnAfterSend;
    function  FPrepareText( var aMsg: TSakMsg): TStringList;
    function  FReceiveTextFromSocket: string;
    procedure FSendTextToSocket( const txt: string);
    function  FSendMail( From: string; AddressList, data: TStringList): integer;
  protected
    { Protected declarations }
    procedure Base64Encode( var AttachedFile: TAttachedFile);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Connect;
    procedure Quit;
    function  SendMessage( var aMsg: TSakMsg): boolean;
    property  Connected: boolean read FConnected;
    property  ReplyCode: string read FReplyCode;
    property  ReplyString: string read FReplyString;
    property  SMTPError: boolean read FSMTPError;
    property  Canceled: boolean read FCanceled write FCanceled;
  published
    { Published declarations }
    property  Port: string read FPort write FPort;
    property  Host: string read FHost write FHost;
    property  LocalizedDates: boolean read FLocalizedDates write FLocalizedDates default false;
    property  EncodeProgressStep: word read FEncodeProgressStep write FEncodeProgressStep;
    property  SendProgressStep: word read FSendProgressStep write FSendProgressStep;
    property  OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
    property  OnQuit: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property  OnError: TOnError read FOnError write FOnError;
    property  OnBeforeSend: TNotifyEvent read FOnBeforeSend write FOnBeforeSend;
    property  OnAfterSend: TNotifyEvent read FOnAfterSend write FOnAfterSend;
    property  OnEncodeStart: TOnCodeStartEvent read FOnEncodeStart write FOnEncodeStart;
    property  OnEncodeProgress: TOnCodeProgressEvent read FOnEncodeProgress write FOnEncodeProgress;
    property  OnEncodeEnd: TNotifyEvent read FOnEncodeEnd write FOnEncodeEnd;
    property  OnSendProgress: TOnSendProgressEvent read FOnSendProgress write FOnSendProgress;
  end;


{=============== SakPOP ===============}

  TSakPOP = class(TComponent)
  private
    { Private declarations }
    FSocket: TClientSocket;
    FSocketStream: TWinSocketStream;
    FSessionState: TSessionState;
    FUserId: string;
    FPasswd: string;
    FPort: string;
    FHost: String;
    FPOPError: boolean;
    FPOPErrorString: string;
    FErrorInFormatOfMsg: string;
    FConnected: boolean;
    FReceivingMsg: boolean;
    FSize: longint;
    FStep: word;
    FReplyCode: string;
    FReplyString: string;
    FCanceled: boolean;
    FServerSupportLastCmd: boolean;

    FDecodeProgress: word;
    FDecodeProgressStep: word;
    FRetrieveProgress: word;
    FRetrieveProgressStep: word;
    FMessagesDeleted: TStringList;
    FMsgsCount: word;

    FOnConnect: TNotifyEvent;
    FOnDisconnect: TNotifyEvent;
    FOnError: TOnError;
    FOnDecodeStart: TOnCodeStartEvent;
    FOnDecodeProgress: TOnCodeProgressEvent;
    FOnDecodeEnd: TNotifyEvent;
    FOnBeforeRetrieve: TOnBeforeRetrieve;
    FOnAfterRetrieve: TNotifyEvent;
    FOnRetrieveProgress: TOnCodeProgressEvent;
    FOnDelete: TOnDeleteEvent;

    procedure FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
    procedure FDoErr( err: integer);
    procedure FDoError( Sender: TObject; Socket: TCustomWinSocket;
                        ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FDoDecodeStart( FileName: string; BytesCount: longint);
    procedure FDoDecodeProgress( Percent: word);
    procedure FDoRetrieveProgress( Percent: word);
    procedure FDoDelete( id: word);
    procedure FDoDecodeEnd;
    procedure FDoBeforeRetrieve( id: word);
    procedure FDoAfterRetrieve;
    function  FindInHeaders( const que: string; const strList: TStringList;
                             var line: integer): boolean;
    function  FindInStringList( const que: string; const strList: TStringList;
                                var line, position: integer): boolean;
    function  FindInStringListCS( const que: string; const strList: TStringList;
                                  var line, position: integer): boolean;
    function  FindUUAttachs( const strList: TStringList;
                             var line: integer;
                             var FileName: string): boolean;
    function  FReceiveTextFromSocket: string;
    procedure FSendTextToSocket( const txt: string);
    procedure GetBasicHeaders( var sakmsg: TSakMsg; Headers: TStringList);
    procedure GetSubHeaders( SubHeaders: TStringList;
                             var CTEncoding: string;
                             var ContentType: string;
                             var FileName: string);
    procedure ProcessAttach( var sakmsg: TSakMsg;
                             var aPart: TStringList;
                             FileName: string;
                             ContentType: string;
                             CTEncoding: string);

  protected
    { Protected declarations }
    procedure Base64Decode( var AttachedFile: TAttachedFile);
    procedure UUDecode( var AttachedFile: TAttachedFile);
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    procedure Connect;
    function  Login: boolean;
    function  Init: word;
    function  RetrieveMessage( id : word): TSakMsg;
    function  RetrieveAllMessages( var SakMsgList: TSakMsgList): integer;
    function  RetrieveHeaders( id : word): string;
    procedure DeleteMessage( id : word);
    procedure Quit;
    property  POPError: boolean read FPOPError;
    property  ErrorString: string read FPOPErrorString;
    property  MsgsCount: word read FMsgsCount;
    property  SessionState: TSessionState read FSessionState;
    property  Connected: boolean read FConnected;
    property  ReplyCode: string read FReplyCode;
    property  ReplyString: string read FReplyString;
    property  Canceled: boolean read FCanceled write FCanceled;
    property  ServerSupportLastCmd: boolean read FServerSupportLastCmd
                                            write FServerSupportLastCmd;
  published
    { Published declarations }
    property  UserId: string read FUserId write FUserId;
    property  Passwd: string read FPasswd write FPasswd;
    property  Port: string read FPort write FPort;
    property  Host: string read FHost write FHost;
    property  ErrorInFormatOfMsg: string read FErrorInFormatOfMsg write FErrorInFormatOfMsg;
    property  DecodeProgressStep: word read FDecodeProgressStep write FDecodeProgressStep;
    property  RetrieveProgressStep: word read FRetrieveProgressStep write FRetrieveProgressStep;
    property  OnConnect: TNotifyEvent read FOnConnect write FOnConnect;
    property  OnQuit: TNotifyEvent read FOnDisconnect write FOnDisconnect;
    property  OnError: TOnError read FOnError write FOnError;
    property  OnDecodeStart: TOnCodeStartEvent read FOnDecodeStart write FOnDecodeStart;
    property  OnDecodeProgress: TOnCodeProgressEvent read FOnDecodeProgress write FOnDecodeProgress;
    property  OnDecodeEnd: TNotifyEvent read FOnDecodeEnd write FOnDecodeEnd;
    property  OnBeforeRetrieve: TOnBeforeRetrieve read FOnBeforeRetrieve write FOnBeforeRetrieve;
    property  OnAfterRetrieve: TNotifyEvent read FOnAfterRetrieve write FOnAfterRetrieve;
    property  OnRetrieveProgress: TOnCodeProgressEvent read FOnRetrieveProgress write FOnRetrieveProgress;
    property  OnDelete: TOnDeleteEvent read FOnDelete write FOnDelete;
  end;

  procedure Register;




implementation
{ $R *.dcr }


const crlf = #13#10;
      esNotConnected = 'Not connected.';
      esInvalidOp = 'Invalid op.';
      esNotOrigin = '"From" field not specified.';
      esNotDestination = '"SendTo" field not specified.';
      // es = exception string
      // this strings are used only in design stage.

procedure Register;
begin
  RegisterComponents('Internet', [TSakPOP, TSakSMTP, TSakMsg, TSakMsgList]);
end;


{ ***************** TAttachedFile ***************** }

constructor TAttachedFile.Create( Collection: TCollection);
begin
     FBodyEncoded := TStringList.Create;
     FBodyBin := TMemoryStream.Create;
     inherited create( Collection);
end;

destructor TAttachedFile.Destroy;
begin
     if Assigned(FBodyBin) then
     begin
          FBodyBin.Clear;
          FBodyBin.Free;
     end;

     if Assigned(FBodyEncoded) then
     begin
          FBodyEncoded.Clear;
          FBodyEncoded.Free;
     end;

     inherited destroy;
end;


procedure TAttachedFile.SaveToFile( fn: string);
begin
     if FBodyBin = nil then Exception.create( esInvalidOp);
     FBodyBin.SaveToFile( fn);
end;

procedure TAttachedFile.SaveToStream( Stream: TStream);
begin
     if FBodyBin = nil then Exception.Create( esInvalidOp);
     FBodyBin.SaveToStream( Stream);
end;

{ ***************** TAttachedFiles ***************** }

constructor TAttachedFiles.create( SakMsg: TSakMsg);
begin
     inherited create( TAttachedFile);
     FSakMsg := SakMsg;
end;

function TAttachedFiles.GetItem( index: integer): TAttachedFile;
begin
     result := TAttachedFile( inherited GetItem( index));
end;

procedure TAttachedFiles.SetItem( index: integer; value: TAttachedFile);
begin
     inherited SetItem( index, value);
end;

function TAttachedFiles.add( fn: string): TAttachedFile;
var
  attach: TAttachedFile;
begin
    attach := TAttachedFile( inherited Add);
    attach.FFileName := ExtractFileName( fn);
    attach.FUNCFileName := fn;
    attach.FMIMEType := sak_GetMIMEType( fn);
    result := attach;
end;


{ ***************** TSakMsg ***************** }

constructor TSakMsg.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FAttachedFiles := TAttachedFiles.create( self);
     FText := TStringList.create;
     FExtraHeaders := TStringList.create; {Craig}
     FHeaders := TStringList.create;
     FPriority := prNormal;
     FCharSet := 'ISO-8859-1';  // you could change this
end;

destructor TSakMsg.destroy;
begin
     FAttachedFiles.Clear; FAttachedFiles.free;
     FText.Clear; FText.Free; {asem}
     FExtraHeaders.Clear; FExtraHeaders.Free; {Craig}
     FHeaders.Clear; FHeaders.Free;
     inherited destroy;
end;

procedure TSakMsg.SetText(Value: TStringList); {asem}
begin
     FText.Assign(Value);
end;

procedure TSakMsg.SetExtraHeaders(Value: TStringList); {Craig}
begin
     FExtraHeaders.Assign(Value);
end;


// by Bob Dane
procedure TSakMsg.SaveToFile(fn: String);
var
                i : integer;
                F : TextFile;
          NewFile : Boolean;
              Msg : TStringList;
const
  MsgStartStr = #219#219#219#219#219;
begin
{  NewFile := not FileExists(fn);
  Msg := FPrepareText(this);

  // Open datafile, if file exist then append data to file
  assignfile(F,fn);
  if NewFile then ReWrite(F) else Append(F);

  Writeln(F, MsgStartStr);
  Writeln(F);
  for i := 0 to Msg.Count-1 do Writeln(F, Msg.strings[i]);

  // Close datafile
  CloseFile(F);}
end;

{ ***************** TSakMsgList ***************** }

constructor TSakMsgList.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     if not ( csDesigning in ComponentState) then
        FList := TList.create;
end;

destructor TSakMsgList.destroy;
begin
     if not ( csDesigning in ComponentState) then
     begin
          FList.Clear;
          FList.Free;
     end;
     inherited destroy;
end;

function  TSakMsgList.Get(Index: Integer): TsakMsg;
begin
     result := TSakMsg( FList.Items[ index]);
end;

procedure TSakMsgList.Put(Index: Integer; Item: TsakMsg);
begin
     FList.Items[ index] := Item;
end;

procedure TSakMsgList.Clear;
begin
     FList.Clear;
end;

function  TSakMsgList.Add(Item: TsakMsg): Integer;
begin
     result := FList.Add( Item);
end;

procedure TSakMsgList.Delete(Index: Integer);
begin
     FList.Delete( index);
end;

function  TSakMsgList.IndexOf(Item: TsakMsg): Integer;
begin
     result := FList.IndexOf( Item);
end;

procedure TSakMsgList.Insert(Index: Integer; Item: TsakMsg);
begin
     FList.Insert( Index, Item);
end;

function  TSakMsgList.Remove(Item: TsakMsg): Integer;
begin
     result := FList.Remove( Item);
end;

function  TSakMsgList.First: TSakMsg;
begin
     result := TSakMsg( FList.first);
end;

function  TSakMsgList.Last: TSakMsg;
begin
     result := TSakMsg( FList.Last);
end;

function  TSakMsgList.GetCount: integer;
begin
     result := FList.Count;
end;

// by Bob Dane
procedure TSakMsgList.SaveToFile(fn: String);
var
  i : integer;
  Item : TSakMsg;
begin
  for i := 0 to Count-1 do
  begin
    Item := items[ i];
    Item.SaveToFile(fn);
  end;
end;

{ ***************** TSakSMTP ***************** }

constructor TSakSMTP.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FConnected := false;
     FPort := '25';
     FEncodeProgressStep := 10;
     FSendProgressStep := 10;
     if not ( csDesigning in ComponentState) then
     begin
          FSocket := TClientSocket.create( AOwner);
          FSocket.ClientType := ctBlocking;
          FSocket.OnConnect := FDoConnect;
          FSocket.OnDisconnect := FDoDisconnect;
          FSocket.OnError := FDoError;
     end;
end;

procedure TSakSMTP.Connect;
begin
     FSocket.Port := StrToIntDef( FPort, 25);
     if sak_IsIPAddress(FHost) then
       begin
            FSocket.Address := FHost;        // Roger
            FSocket.Host := '';              // Roger
       end
     else
       begin
            FSocket.Host := FHost;          // Sergio
            FSocket.Address := '';          // Sergio
       end;

     FSMTPError := false;
     try {Craig}
       FSocket.Open;
     except
       FSMTPError := True;
       exit;
     end;

     FSocketStream := TWinSocketStream.create( FSocket.Socket, 20);
                                                    // 20 = timeout
                                                    // not documented in D3.00
                                                    // but NEEDED !
     if FSMTPError then exit;

     while not FConnected do Application.ProcessMessages;
     FReceiveTextFromSocket;
     while (FReplyCode <> '220') and (FReplyCode <> '421') do
     begin
          FReceiveTextFromSocket;
          Application.ProcessMessages;
          if not FConnected then exit;
     end;
     FSMTPError := FReplyCode <> '220';
     if FSMTPError then
     begin
          FDoErr( eeConnect);
          exit;
     end;

     FSendTextToSocket( 'HELO ' + FSocket.Socket.LocalHost + crlf);
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
        FDoErr( eeConnect);
     FCanceled := False;
end;

procedure TSakSMTP.FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := true;
     if assigned( FOnConnect) then FOnConnect( Sender);
end;

procedure TSakSMTP.Quit;
begin
     if FConnected then
     begin
          if FCanceled
          then begin
                    FSocketStream.Free;
                    FSocket.close;
                    FConnected := false;
               end
          else begin
                    try
                         FSendTextToSocket( 'QUIT' +crlf);
                         FReceiveTextFromSocket;
                         FSMTPError := FReplyCode <> '221';
                         if FSMTPError then
                            FDoErr( eeDisconnect);
                      finally
                         FSocketStream.Free;
                         FSocket.close;
                         FConnected := false;
                    end
               end;
     end;
end;


function TSakSMTP.SendMessage( var aMsg: TSakMsg): boolean;
var x, y: integer;
    MsgTOs, MsgCCs, MsgBCCs: TStringList;
    FromAux: string;
    StrListMsg: TStringList;
begin
     result := false;

     if not FConnected then
        Exception.create( esNotConnected);
     if aMsg.From = '' then
        Exception.create( esNotOrigin);
     if aMsg.SendTo = '' then
        Exception.create( esNotDestination);

     aMsg.FDate := sak_GetInternetDate( Now);

     StrListMsg := FPrepareText( aMsg);
     if FCanceled then begin
                          StrListMsg.Free;                            //<cg>
                          exit;
                       end;

     DoOnBeforeSend;

     FromAux := aMsg.From;
     x := Pos('<', FromAux);
     y := Pos('>', FromAux);
     if x > 0 then FromAux := copy( FromAux, x+1, y-x-1);   // modified by Roger Reghin
                                                            // and then by Sergio, again :)

     MsgTOs  := sak_CleanUpAddresses( aMsg.SendTo);
     MsgCCs  := sak_CleanUpAddresses( aMsg.CC);
     MsgBCCs := sak_CleanUpAddresses( aMsg.BCC);

     try
        if FSendMail( FromAux, MsgTOs, StrListMsg) < 1 then
           FDoErr( eeGeneral);
        if FSendMail( FromAux, MsgCCs, StrListMsg) < 1 then
           FDoErr( eeGeneral);
        if FSendMail( FromAux, MsgBCCs, StrListMsg) < 1 then
           FDoErr( eeGeneral);
     finally
        StrListMsg.Free;
        MsgTOs.Free;
        MsgCCs.Free;
        MsgBCCs.Free;
     end;

     if FSendProgress < 100 then FDoSendProgress( 100);
     result := true;
     DoOnAfterSend;
end;

function TSakSMTP.FSendMail( From: string; AddressList, data: TStringList): integer;
var i: integer;
    step: word;
begin
     result := 1;

     if AddressList.Count = 0 then exit;
     FSendTextToSocket( 'MAIL FROM:' + '<' + From + '>' + crlf);
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
     begin
          result := -1;
          exit;
     end;

     for i := 0 to AddressList.Count-1 do
     begin
          FSendTextToSocket( 'RCPT TO:' + '<' + AddressList[ i] + '>' + crlf);

          FReceiveTextFromSocket;
          FSMTPError := FReplyCode <> '250';
          if FSMTPError then
          begin
               result := -2;
               exit;
          end;
     end;

     FSendTextToSocket( 'DATA' +crlf);
     FReceiveTextFromSocket;
     FSMTPError := (FReplyCode <> '354'); // and (FReplyCode <> '250');
     if FSMTPError then
     begin
          result := -3;
          exit;
     end;

     step := FSendProgressStep;

     for i := 0 to data.Count-1 do
     begin
          FSendTextToSocket( data[ i] + crlf);
          FSendProgress := round( 100*i/data.Count);
          if ( FSendProgress >= step) then
          begin
               FDoSendProgress( FSendProgress);
               inc( step, FSendProgressStep);
          end;
          Application.ProcessMessages;
          if FCanceled then
          begin
               result := 0;
               exit;
          end;
          {$IFDEF DELPHI3}
          Sleep( 20);
          // this solve a hard freeze of the system, I don't know why
          {$ENDIF}
     end;
     FSendTextToSocket( crlf + '.' + crlf);     // end of msg
     FReceiveTextFromSocket;
     FSMTPError := FReplyCode <> '250';
     if FSMTPError then
     begin
          result := -4;
          exit;
     end;
end;

function TSakSMTP.FPrepareText( var aMsg: TSakMsg): TStringList;
var i: integer;
    boundary, UsrName: string;
    body, Headers: TStringList;
    AttFile: TAttachedFile;
begin
     result := nil;
     Headers := TStringList.Create;
     Body := TStringList.Create;

     Body.Text := aMsg.Text.Text;

     i := 0;
     while i < Body.Count do
     begin
          if pos( '.', Body[i]) = 1 then Body[i] := '.' + Body[i];
          inc( i)                         // agregamos transparency
     end;

     UsrName := AMsg.UserName;

     Headers.Add('Message-Id: ' + sak_MakeUniqueId( FSocket.Socket.LocalHost));
     if aMsg.InReplyTo <> '' then Headers.Add('In-Reply-To: ' + aMsg.InReplyTo);

     Headers.Add('Date: ' + aMsg.Date);
     Headers.Add('X-Priority: ' + IntToStr(Integer(aMsg.Priority) + 1));

     if UsrName <> '' then begin
                                if (pos( '@', aMsg.From) = 0)
                                then Headers.Add('From: ' + '"' + UsrName + '" <' +
                                                  aMsg.From + '@' + Host + '>')
                                else Headers.Add('From: ' + '"' + UsrName + '" <' +
                                                  aMsg.From + '>');
                           end
                      else Headers.Add('From: ' + aMsg.From);
     if aMsg.ReplyTo <> '' then Headers.Add('Reply-To: ' + aMsg.ReplyTo);
     Headers.Add('X-Mailer: ' + Application.Title);
     Headers.Add('To: ' + aMsg.SendTo);
     if aMsg.CC <> '' then Headers.Add('CC: ' + aMsg.CC); {Craig}
//     if aMsg.BCC <> '' then Headers.Add('BCC: ' + aMsg.BCC);
//     not valid according to the RFC822
     Headers.Add('Subject: ' + aMsg.Subject);
     Headers.Add('MIME-Version: 1.0');

     if aMsg.attachedFiles.count = 0 then
     begin
          Headers.Add( 'Content-Type: Text/Plain; charset=' + aMsg.FCharSet);
          Headers.Add( 'Content-Transfer-Encoding: 8bit');
     end;

     if aMsg.attachedFiles.count > 0 then
     begin
        boundary := sak_GenerateBoundary;
        Headers.Add( 'Content-Type: multipart/mixed; boundary="' + boundary + '"');
        boundary := '--' + boundary;
        Body.Insert( 0, boundary);
        Body.Insert( 1, 'Content-Type: Text/Plain; charset=' + aMsg.FCharSet);
        Body.Insert( 2, 'Content-Transfer-Encoding: 8bit');
        Body.Insert( 3, '');
        for i := 0 to aMsg.attachedFiles.count-1 do
        begin
             AttFile := aMsg.AttachedFiles[ i];
             Body.Add( boundary);
             Body.Add( 'Content-Type: ' + AttFile.MIMEType +
                       '; name="' + AttFile.FileName + '"');
             Body.Add( 'Content-Transfer-Encoding: base64');
             Body.Add( 'Content-Disposition: inline; FileName="' +
                       aMsg.AttachedFiles[ i].FileName + '"');
             Body.Add( '');
             Base64Encode( AttFile);

             Application.ProcessMessages;
             if FCanceled then begin
                                  Headers.Clear; Headers.Free;
                                  Body.Clear; Body.Free;
                                  exit;
                               end;

             Body.AddStrings( AttFile.FBodyEncoded);
        end;
        Body.Add( '');
        Body.Add( boundary + '--');
        Body.Add( '');
     end;

     Headers.AddStrings( aMsg.FExtraHeaders); {Craig}

     result := TStringList.Create;
     result.AddStrings( Headers);
     result.Add( '');
     result.AddStrings( Body);
     Headers.Clear; Headers.Free;
     Body.Clear; Body.Free;
end;



procedure TSakSMTP.Base64Encode( var AttachedFile: TAttachedFile);
const _Code64: string[64] =
      ('ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/');
var
   i, BytesCoded: longint;
   b: array[0..2279] of byte;
   j,k,l,m, quads, step: integer;
   stream: string[76];
   TextCoded: TStringList;
   TextBin: TFileStream;
begin
     TextBin := TFileStream.Create( AttachedFile.FUNCFileName, fmOpenRead or fmShareDenyNone);
     FDoEncodeStart( AttachedFile.FFileName, TextBin.Size);
     TextCoded := TStringList.Create;
     stream := '';
     step := FEncodeProgressStep;
     BytesCoded := 0;
     quads := 0;
     j := TextBin.Size div 2280;
     for i := 1 to j do
     begin
          Application.ProcessMessages;
          if FCanceled then begin
                                 TextBin.Free;
                                 TextCoded.Clear; TextCoded.Free;
                                 exit;
                            end;
          TextBin.Read( b, 2280);
          for m:=0 to 39 do
          begin
               for k:=0 to 18 do
               begin
                    l:=57*m+3*k;
                    stream[quads+1]:=_Code64[(b[l]div 4)+1];
                    stream[quads+2]:=_Code64[(b[l] mod 4)*16 +(b[l+1] div 16)+1];
                    stream[quads+3]:=_Code64[(b[l+1] mod 16)*4 +(b[l+2] div 64)+1];
                    stream[quads+4]:=_Code64[b[l+2] mod 64+1];
                    Inc(quads,4);
                    if quads=76 then
                    begin
                         stream[0]:=#76;
                         TextCoded.Add( stream);
                         inc( BytesCoded, 57);
                         FEncodeProgress := round( 100*BytesCoded/TextBin.Size);
                         if ( FEncodeProgress >= step) then
                         begin
                              FDoEncodeProgress( FEncodeProgress);
                              inc( step, FEncodeProgressStep);
                         end;
                         Application.ProcessMessages;
                         quads:=0;
                    end;
               end;
          end;
     end;
     j:= (TextBin.Size mod 2280) div 3;
     for i:=1 to j do
     begin
          Application.ProcessMessages;
          if FCanceled then begin
                                 TextBin.Free;
                                 TextCoded.Clear; TextCoded.Free;
                                 exit;
                            end;
          TextBin.Read( b, 3);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +(b[1] div 16)+1];
          stream[quads+3]:=_Code64[(b[1] mod 16)*4 +(b[2] div 64)+1];
          stream[quads+4]:=_Code64[b[2] mod 64+1];
          Inc(quads,4);
          if quads=76 then
          begin
               stream[0]:=#76;
               TextCoded.Add( stream);
               quads:=0;
          end;
     end;
     if (TextBin.Size mod 3) = 2 then
     begin
          TextBin.Read( b, 2);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +(b[1] div 16)+1];
          stream[quads+3]:=_Code64[(b[1] mod 16)*4 +1];
          stream[quads+4]:='=';
          Inc(quads,4);
     end;
     if (TextBin.Size mod 3) = 1 then
     begin
          TextBin.Read( b, 1);
          stream[quads+1]:=_Code64[(b[0]div 4)+1];
          stream[quads+2]:=_Code64[(b[0] mod 4)*16 +1];
          stream[quads+3]:='=';
          stream[quads+4]:='=';
          Inc(quads,4);
     end;
     TextBin.Free;  // release this ASAP
     stream[0]:=Chr(quads);
     if quads > 0 then TextCoded.Add( stream);
     if FEncodeProgress < 100 then FDoEncodeProgress( 100);
     Application.ProcessMessages;
     if FCanceled then begin
                            TextCoded.Clear; TextCoded.Free;
                            exit;
                       end;
     AttachedFile.FBodyEncoded.Assign( TextCoded );
     TextCoded.Clear; TextCoded.Free;
     FDoEncodeEnd;
end;


procedure TSakSMTP.FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := false;
     if assigned( FOnDisconnect) then FOnDisconnect( Sender);
end;


function TSakSMTP.FReceiveTextFromSocket: string;
var s: string;
    i, x : integer;
    buff: array[1..1024] of char;
begin
     repeat
           while not FSocketStream.WaitForData( 200) do Application.ProcessMessages;
           x := FSocketStream.read( buff, 1024);
           s := copy( buff, 1, x);
           i := pos( crlf, s);
           while (i > 0) and (length( s) > i+2) do  // *****  new  (by Dmitry Bondarenko)
            begin
             s := copy( s, i+2, length(s)-i-1);
             i := pos( crlf, s);
            end;                                    //************* end of new
           FReplyCode := trim( copy( s, 1, 3));
           FReplyString := trim( copy( s, 4, 64));
           result := s;
           Application.ProcessMessages;
           if length( s) < 4 then s := '----';
     until s[4] = ' ';
     // because the replys that are like '250-OK' are not final,
     // replys like '250 OK' are finals, note the fourth char
end;

procedure TSakSMTP.FSendTextToSocket( const txt: string);
begin
     FSocketStream.write( Pointer( txt)^, length( txt));
end;

procedure TSakSMTP.DoOnBeforeSend;
begin
     if assigned( FOnBeforeSend) then FOnBeforeSend( self);
end;

procedure TSakSMTP.DoOnAfterSend;
begin
     if assigned( FOnAfterSend) then FOnAfterSend( self);
end;

procedure TSakSMTP.FDoErr( ErrorEvent: TErrorEvent);
var x: integer;
begin
     x := 0;
     FDoError( self, FSocket.Socket, ErrorEvent, x);
end;

procedure TSakSMTP.FDoError( Sender: TObject; Socket: TCustomWinSocket;
                             ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
     FSMTPError := true;
     FSocketStream.Free;
     FSocket.close;
     FConnected := false;
     if assigned( FOnError) then FOnError( Sender, StrToInt( FReplyCode), FReplyString);
end;

procedure TSakSMTP.FDoEncodeStart( FileName: string; Size: longint);
begin
     if assigned( FOnEncodeStart) then FOnEncodeStart( self, FileName, Size);
end;

procedure TSakSMTP.FDoEncodeProgress( Percent: word);
begin
     if assigned( FOnEncodeProgress) then FOnEncodeProgress( self, Percent);
end;

procedure TSakSMTP.FDoEncodeEnd;
begin
     if assigned( FOnEncodeEnd) then FOnEncodeEnd( self);
end;

procedure TSakSMTP.FDoSendProgress( Percent: word);
begin
     if assigned( FOnSendProgress) then FOnSendProgress( self, Percent);
end;


{ ***************** TSakPOP ***************** }

constructor TSakPOP.create( AOwner: TComponent);
begin
     inherited create( AOwner);
     FConnected := false;
     FPort := '110';
     FDecodeProgressStep := 10;
     FRetrieveProgressStep := 10;
     FReceivingMsg := false;
     FErrorInFormatOfMsg := 'Error en el formato del mensaje.';
     if not ( csDesigning in ComponentState) then
     begin
          FSocket := TClientSocket.create( AOwner);
          FSocket.ClientType := ctBlocking;
          FSocket.OnConnect := FDoConnect;
          FSocket.OnDisconnect := FDoDisconnect;
          FSocket.OnError := FDoError;
     end;
end;

procedure TSakPOP.Connect;
begin
     FMessagesDeleted := TStringList.create;
     FMsgsCount := 0;
     FSocket.port := StrToIntDef( FPort, 110);
     if sak_IsIPAddress(FHost) then
       begin
            FSocket.Address := FHost;        // Roger
            FSocket.Host := '';              // Roger
       end
     else
       begin
            FSocket.Host := FHost;          // Sergio
            FSocket.Address := '';          // Sergio
       end;

     FPOPError := false;
     try {Craig}
       FSocket.Open;
     except
       FPOPError := True;
       exit;
     end;

     if FConnected then
     begin
          FSocketStream := TWinSocketStream.create( FSocket.Socket, 100);
          FReceiveTextFromSocket;
          FSessionState := Authorization;
          FCanceled := False;
          if FPOPError then FDoErr( 2000);
     end;
end;

procedure TSakPOP.FDoConnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := true;
     if assigned( FOnConnect) then FOnConnect( Sender);
end;

function TSakPOP.Login: boolean;
begin
     result := false;
     if not FConnected then
        Exception.create( 'Invalid Op. Not connected.');

     FSendTextToSocket( 'USER ' + UserId +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2001); exit; end;

     FSendTextToSocket( 'PASS ' + passwd +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2001); exit; end;

     result := true;
     FSessionState := Transaction;
end;

function TSakPOP.Init: word;
// this function must return the number of _new_ mails
// but it will _not_ work with servers that do not
// support the LAST comand.
// it seems that the last POP3 revision remove this
// command, very smart, ha ?
begin
     result := 0;  // 0 new mails, anyone has a better idea ?
     FSendTextToSocket( 'STAT' +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2006); exit; end;

     FMsgsCount := sak_StrWord2Int( FReplyString, 1, 0);

     FServerSupportLastCmd := true;
     FSendTextToSocket( 'LAST' + crlf);
     FReceiveTextFromSocket;
     if FPOPError then
     begin
          FServerSupportLastCmd := false;
          exit;
     end;

     result := FMsgsCount - sak_StrWord2Int( FReplyString, 1, 0);
end;

procedure TSakPOP.Quit;
begin
     if FConnected then
        begin
             FSendTextToSocket( 'QUIT' +crlf);
             FReceiveTextFromSocket;
             if FPOPError then FDoErr( 2002)
                          else begin
                                 FMessagesDeleted.free;
                                 FSocketStream.Free;
                                 FSocket.close;
                                 FConnected := false;
                               end;
        end;
end;

procedure TSakPOP.DeleteMessage( id : word);
begin
     if not FConnected then
        Exception.create( esNotConnected);

     Application.ProcessMessages;
     if FCanceled then exit;

     FSendTextToSocket( 'DELE ' + intToStr( id) +crlf);
     FReceiveTextFromSocket;
     if FPOPError then begin FDoErr( 2003); exit; end;

     FMessagesDeleted.Add( intToStr( id));
     dec( FMsgsCount);
     FDoDelete( id);
end;

function TSakPOP.RetrieveMessage( id : word): TSakMsg;
const EOM = crlf+'.'+crlf;
var i, p, x, line, position: integer;
    s, boundary, endOfMsg, ContentType,
    CTEncoding, FileName, tmpFileName: string;
    sakMsg: TSakMsg;
    Headers, SubHeaders, aPart, StrListMsg: TStringList;
    Partes: TList;
    AttFile: TAttachedFile;
    AllMsg: TFileStream;
    found: boolean;
begin
     result := nil;
     if not FConnected then
        Exception.create( esNotConnected);

     FDoBeforeRetrieve( id);

     tmpFileName := sak_GetTempFileName;

     AllMsg := TFileStream.Create( tmpFileName, fmCreate);
// by Dmitry Bondarenko
     FSendTextToSocket( 'LIST ' + intToStr( id) + crlf);
     s := FReceiveTextFromSocket;
     FSize := sak_StrWord2Int( FReplyString, 2, 100);
//end of Dmitry
     FSendTextToSocket( 'RETR ' + intToStr( id) + crlf);
     s := FReceiveTextFromSocket;
     if FPOPError then
     begin
          AllMsg.Free;
          DeleteFile( tmpFileName);
          FDoErr( 2004);
          exit;
     end;

     FStep := FRetrieveProgressStep;

     AllMsg.Write( Pointer( s)^, length( s));
     while pos( EOM, s) = 0 do
     begin
          Application.ProcessMessages;
          if FCanceled then
          begin
               AllMsg.Free;
               DeleteFile( tmpFileName);
               result := nil;
               exit;
          end;
          s := copy( s, length( s)-3, 4) + FReceiveTextFromSocket;
          AllMsg.Write( s[5], length( s)-4);
          FRetrieveProgress := round( 100*AllMsg.size/FSize);
          if ( FRetrieveProgress >= FStep) then
          begin
               FDoRetrieveProgress( FRetrieveProgress);
               inc( FStep, FRetrieveProgressStep);
          end;
     end;

     if FRetrieveProgress < 100 then FDoRetrieveProgress( 100);

     AllMsg.Position := 0;
     StrListMsg := TStringList.Create;
     StrListMsg.LoadFromStream( AllMsg);
     AllMsg.Free;
     DeleteFile( tmpFileName);
     StrListMsg.Delete( 0);
     StrListMsg.delete( StrListMsg.count-1);             // borro el EOM

     { -- begin of parsing -- :( }
     Headers := TStringList.create;
     sakMsg := TSakMsg.create( self);

     i := StrListMsg.IndexOf( '');
     if i <> -1 then for p := 0 to i do headers.Add( StrListMsg[p]);

     for p := 0 to i do StrListMsg.delete( 0);  // delete all the headers

     i := 0;
     while i < StrListMsg.Count-1 do
     begin
          x := Length( StrListMsg[ i]);
          if (pos( '.', StrListMsg[ i]) = 1) and (x > 1) then
             StrListMsg[ i] := copy( StrListMsg[ i], 2, x);
          inc( i);                   // get out transparency
     end;

     GetBasicHeaders( sakMsg, Headers);
     sakMsg.FSubject := sak_ConvertCharSet( PChar( sakMsg.FSubject));
     sakMsg.FFrom := sak_ConvertCharSet( PChar( sakMsg.FFrom));
     sakMsg.FSendTo := sak_ConvertCharSet( PChar( sakMsg.FSendTo));
     sakMsg.FCC := sak_ConvertCharSet( PChar( sakMsg.FCC));

     GetSubHeaders( Headers, CTEncoding, ContentType, FileName);
     sakMsg.FContentType := ContentType;
     sakMsg.FContentTransferEncoding := CTEncoding;

// a normal email message, maybe with a uucoded attach

     if (sakMsg.FContentType = '') or
        (pos( 'TEXT', sakMsg.FContentType) > 0) or
        (pos( 'MESSAGE', sakMsg.FContentType) > 0) or
        (pos( 'PGP', sakMsg.FContentType) > 0)or
        (sakMsg.FContentType = 'MULTIPART/REPORT') then
     begin
          {search for UUcoded files}
          while FindUUAttachs( StrListMsg, line, FileName) do
          begin
               aPart := TStringList.create;
               while lowercase( trim( StrListMsg[ line])) <> 'end' do
               begin
                    if StrListMsg[ line] <> '' then aPart.Add( StrListMsg[ line]);
                    StrListMsg.Delete( line);
               end;
               sakMsg.attachedFiles.add( FileName);
               AttFile := sakMsg.attachedFiles[ sakMsg.attachedFiles.count-1];
               AttFile.FBodyEncoded.Assign( aPart);
               UUDecode( AttFile);
               AttFile.FBodyEncoded.Clear;
               aPart.Clear; aPart.Free;
          end;
          sakMsg.FText.AddStrings( StrListMsg);
          if CTEncoding = 'QUOTED-PRINTABLE' then
          begin
               sakMsg.Text.Text := sak_QuotedPrintableDecode( PChar( sakMsg.Text.Text));
          end;
          // clean up
          Headers.Clear; Headers.Free;
          StrListMsg.Clear; StrListMsg.Free;

          result := sakMsg;
          FDoAfterRetrieve;
          exit;
     end;


//   this is a msg whitout any text, just an attached file
//   codified in base64 or uucode


     if (CTEncoding = 'BASE64') or (CTEncoding = 'X-UUENCODE') then
     begin
          ProcessAttach( sakmsg, strListMsg, FileName, ContentType, CTEncoding);

          result := sakMsg;
          StrListMsg.Clear; StrListMsg.Free;
          Headers.Clear; Headers.Free;
          FDoAfterRetrieve;
          exit;
     end;


     // this only if is multipart/mixed or some variant

     found := FindInStringList( 'BOUNDARY', Headers, line, position);
     if not found then raise Exception.Create( FErrorInFormatOfMsg);

     s := Headers.strings[ line];
     boundary := sak_GetBoundaryOutOfLine( s, position);
     endOfMsg := boundary + '--';

     Partes := TList.create;
     aPart := TStringList.create;

     found := FindInStringListCS( boundary, StrListMsg, line, position);
     if not found then raise Exception.Create( FErrorInFormatOfMsg);

     inc( line);
     while StrListMsg[ line] <> endOfMsg do
     begin
          if StrListMsg[ line] = boundary then
          begin
               Partes.add( aPart);
               aPart := TStringList.create;
               inc( line);
          end;
          aPart.add( StrListMsg[ line]);
          inc( line);
          if line = StrListMsg.Count then break;
     end;
     Partes.add( aPart);
     // this add the last part that is not added in the while loop

     StrListMsg.Clear; StrListMsg.Free;
     Headers.Clear; Headers.Free;

     for p := 0 to Partes.count-1 do
     begin
         aPart := TStringList( Partes[ p]);

         SubHeaders := TStringList.Create;  // SubHeaders are headers of the sub-parts
         i := 0;                             // _not_ the main headers
         while aPart[i] <> '' do begin
                                      SubHeaders.Add( aPart[i]);
                                      inc( i);
                                 end;

         GetSubHeaders( SubHeaders, CTEncoding, ContentType, FileName);
         FileName := sak_ConvertCharSet( PChar(FileName));

         if (CTEncoding = 'BASE64') or
            (ContentType = 'TEXT/HTML') or
            (CTEncoding = 'X-UUENCODE') or
            (FileName <> '')
         then ProcessAttach( sakmsg, aPart, FileName, ContentType, CTEncoding)
         else begin
                   while aPart[ 0] <> '' do aPart.delete( 0);
                   aPart.delete( 0);
                   sakMsg.Text.AddStrings( aPart);
                   if CTEncoding = 'QUOTED-PRINTABLE' then
                   begin
                        sakMsg.Text.Text := sak_QuotedPrintableDecode( PChar( sakMsg.Text.Text));
                   end;
              end;
         SubHeaders.Clear; SubHeaders.Free;
         aPart.Clear; aPart.Free;
         // this must be freeing the list
     end;

     Partes.Clear; Partes.Free;
     result := sakMsg;
     FDoAfterRetrieve;
end;

procedure TSakPOP.GetBasicHeaders( var sakmsg: TSakMsg; Headers: TStringList);
var found: boolean;
    line, x: integer;
begin
     sakMsg.From := copy( Headers.strings[0], length( 'From ') + 1, 72);

     sakMsg.FHeaders.AddStrings( Headers);

     found := FindInHeaders( 'FROM:', Headers, line);
     if found then
     begin
          sakMsg.FFrom := trim( copy( Headers[ line], length('FROM: ')+1, 127));
          x := 1;
          if (Headers[line+x] <> '') then
          while (Headers[line+x][1] = ' ') or (Headers[line+x][1] = #9) do
          begin
               sakMsg.FFrom := sakMsg.FFrom + trim( Headers[line+x]);
               inc( x);
          end;
     end;
     // he encontrado casos en que ocupa mas de una linea  >:|

     found := FindInHeaders( 'MESSAGE-ID:', Headers, line);
     if found then sakMsg.FMessageId := trim( copy( Headers[ line], 13, 127));

     found := FindInHeaders( 'IN-REPLY-TO:', Headers, line);
     if found then sakMsg.FInReplyTo := trim( copy( Headers[ line], 14, 127));

     found := FindInHeaders( 'RETURN-PATH:', Headers, line);
     if found then sakMsg.FReturnPath := trim( copy( Headers[ line], 14, 127));

     found := FindInHeaders( 'REPLY-TO:', Headers, line);
     if found then
     begin
          sakMsg.FReplyTo := copy( Headers[ line], 11, 127);
          x := 1;
          if (Headers[line+x] <> '') then
          while (Headers[line+x][1] = ' ') or (Headers[line+x][1] = #9) do
          begin
               sakMsg.FReplyTo := sakMsg.FReplyTo + trim( Headers[line+x]);
               inc( x);
          end;
     end;

     found := FindInHeaders( 'TO:', Headers, line);
     if found then
     begin
          sakMsg.FSendTo := trim( copy( Headers[ line], 5, length( Headers[ line])-3));
          x := 1;
          if (Headers[line+x] <> '') then
          while (Headers[line+x][1] = ' ') or (Headers[line+x][1] = #9) do
          begin
               sakMsg.FSendTo := sakMsg.FSendTo + ' ' + trim( Headers[line+x]);
               inc( x);
          end;
     end;

     found := FindInHeaders( 'CC:', Headers, line);
     if found then
     begin
          sakMsg.FCC := trim( copy( Headers[ line], 5, length( Headers[ line])-3));
          x := 1;
          if (Headers[line+x] <> '') then
          while (Headers[line+x][1] = ' ') or (Headers[line+x][1] = #9) do
          begin
               sakMsg.FCC := sakMsg.FCC + ' ' + trim( Headers[line+x]);
               inc( x);
          end;
     end;

     found := FindInHeaders( 'DATE:', Headers, line);
     if found then sakMsg.FDate := trim( copy( Headers[ line], 7, 72));

     found := FindInHeaders( 'SUBJECT:', Headers, line);
     if found then sakMsg.FSubject := Trim( copy( Headers[ line], 10, length( Headers[ line])));

     found := FindInHeaders( 'CONTENT-TYPE:', Headers, line);
     if found then
     begin
          sakMsg.FContentType := upperCase( Trim( copy( Headers[ line], 15, 72)));
          x := pos( ';', sakMsg.FContentType);
          if x > 0 then sakMsg.FContentType := copy( sakMsg.FContentType, 1, x-1);
     end;
end;

procedure TSakPOP.GetSubHeaders( SubHeaders: TStringList;
                                 var CTEncoding: string;
                                 var ContentType: string;
                                 var FileName: string);
var found: boolean;
    line, x, position: integer;
begin
       found := FindInHeaders( 'CONTENT-TRANSFER-ENCODING:', SubHeaders, line);
       if found then
          begin
               CTEncoding := uppercase( trim( copy( SubHeaders[ line], 28, 20)));
               x := pos( ';', ContentType);
               if x > 0 then ContentType := copy( ContentType, 1, x-1);
          end
       else CTEncoding := '';

       found := FindInHeaders( 'CONTENT-TYPE:', SubHeaders, line);
       if found then
          begin
               ContentType := upperCase( Trim( copy( SubHeaders[ line], 15, 72)));
               x := pos( ';', ContentType);
               if x > 0 then ContentType := copy( ContentType, 1, x-1);
          end
       else ContentType := '';

       FileName := '';
       found := FindInStringList( 'FILENAME=', SubHeaders, line, position);
       if found
       then begin
                  FileName := trim( copy( SubHeaders[ line], position+length('FILENAME='), 127));
                  x := pos( ';', FileName);
                  if x > 0 then FileName := copy( FileName, 1, x-1);
                  if FileName[1] = #34 then  // if it is enclosed between "
                  begin
                       delete( FileName, 1, 1);  // here we delete the first and last "
                       delete( FileName, length( FileName), 1);
                  end;
            end
       else begin
                 found := FindInStringList( 'NAME=', SubHeaders, line, position);
                 if found
                 then begin
                           FileName := trim( copy( SubHeaders[ line], position+length('NAME='), 127));
                           x := pos( ';', FileName);
                           if x > 0 then FileName := copy( FileName, 1, x-1);
                           if FileName[ 1] = #34 then
                           begin
                                delete( FileName, 1, 1);
                                delete( FileName, length( FileName), 1);
                           end;
                      end;
            end;
end;


procedure TSakPOP.ProcessAttach( var sakmsg: TSakMsg; var aPart: TStringList;
                                 FileName: string; ContentType: string;
                                 CTEncoding: string);
const
     NoValidChars = '\/:*?"<>|';
var
   i, x: integer;
   AttFile: TAttachedFile;
begin
          for i := 1 to length(NoValidChars) do
          begin
              repeat
                    x := pos( NoValidChars[i], FileName);
                    if x > 0 then delete( FileName, x, 1);
              until x = 0;
          end;

          if (FileName = '') and (ContentType = 'TEXT/HTML')
             then FileName := sakMsg.FSubject;

          if (ContentType = 'TEXT/HTML') and (pos( '.', FileName) = 0)
             then FileName := FileName + '.html';

          sakMsg.attachedFiles.add( FileName);

          while (trim(aPart[ 0]) <> '') do aPart.delete( 0);
          if (CTEncoding = 'BASE64') or (CTEncoding = 'X-UUENCODE')
             then while (aPart.Count > 0) and (trim( aPart[ 0]) = '')
                        do aPart.delete( 0)
             else aPart.Delete( 0);
          AttFile := sakMsg.attachedFiles[ sakMsg.attachedFiles.count-1];
          if CTEncoding ='BASE64'
          then begin
                    AttFile.FBodyEncoded.Assign( aPart);
                    Base64Decode( AttFile);
                    AttFile.FBodyEncoded.Clear;
               end
          else if CTEncoding ='X-UUENCODE'
               then begin
                         AttFile.FBodyEncoded.Assign( aPart);
                         UUDecode( AttFile);
                         AttFile.FBodyEncoded.Clear;
                    end
               else begin
                         aPart.delete( aPart.count -1);
                         AttFile.FBodyBin.Write( Pointer( aPart.text)^, length( aPart.text));
                    end;
end;


function TSakPOP.RetrieveAllMessages( var SakMsgList: TSakMsgList): integer;
var i, count: integer;
    aSakMsg: TSakMsg;
begin
     SakMsgList.clear;
     count := 0;
     for i := 1 to FMsgsCount do
     begin
         if FMessagesDeleted.IndexOf( intToStr( i)) = -1 then
         begin
              aSakMsg := RetrieveMessage( i);
              Application.ProcessMessages;
              if FCanceled then break
                           else begin
                                     SakMsgList.add( aSakMsg);
                                     inc( count);
                                end;
         end;
     end;
     result := count;
end;

function TSakPOP.RetrieveHeaders( id : word): string;
const EOM = crlf+'.'+crlf;
var   s: string;
begin
     if not FConnected then
        Exception.create( esNotConnected);

     result := '';
     FSendTextToSocket( 'TOP ' + intToStr( id) + ' 0'+crlf);
     s := FReceiveTextFromSocket;
     if not FPOPError then
        begin
             delete( s, 1, pos( crlf, s));    // remove the +OK
             while pos( EOM, s) = 0 do
             begin
                  s := s + FReceiveTextFromSocket;
             end;
             result := s;
        end
     else
        FDoErr( 2005);
end;


procedure TSakPOP.Base64Decode( var AttachedFile: TAttachedFile);
var
   a1: array[1..4] of byte;
   b1: array[1..3] of byte;
   i, j, step:  integer;
   byte_ptr,real_bytes: integer;
   buff: TFileStream;
   Txt: TStringList;
   line, tmpFileName: string;
begin
     Txt := AttachedFile.FBodyEncoded;
     FDoDecodeStart( AttachedFile.FileName, Txt.Count);
     step := FDecodeProgressStep;

     tmpFileName := sak_GetTempFileName;

     buff := TFileStream.Create( tmpFileName, fmCreate);
     byte_ptr:=0;

     try
         for i := 0 to Txt.Count-1 do
         begin
              line := Txt[i];
              for j := 1 to Length( line) do
              begin
                   Inc( byte_ptr);
                   case line[j] of
                        'A'..'Z': a1[byte_ptr] := Ord( line[j])-65;
                        'a'..'z': a1[byte_ptr] := Ord( line[j])-71;
                        '0'..'9': a1[byte_ptr] := Ord( line[j])+4;
                        '+': a1[byte_ptr] := 62;
                        '/': a1[byte_ptr] := 63;
                        '=': a1[byte_ptr] := 64;
                   end;
                   if byte_ptr = 4 then
                   begin
                        byte_ptr := 0;
                        real_bytes := 3;
                        if a1[1] = 64 then real_bytes:=0;
                        if a1[3] = 64 then
                        begin
                             a1[3] := 0;
                             a1[4] := 0;
                             real_bytes := 1;
                        end;
                        if a1[4]=64 then
                        begin
                             a1[4] := 0;
                             real_bytes := 2;
                        end;
                        b1[1] := a1[1]*4+(a1[2] div 16);
                        b1[2] := (a1[2] mod 16)*16+(a1[3]div 4);
                        b1[3] := (a1[3] mod 4)*64 +a1[4];

                        buff.Write( b1, real_bytes);
                        FDecodeProgress := Round(100*i/Txt.Count);
                        if ( FDecodeProgress >= step) then
                        begin
                             FDoDecodeProgress( FDecodeProgress);
                             inc( step, FDecodeProgressStep);
                        end;
                        Application.ProcessMessages;
                   end;
              end;
         end;
         buff.Position := 0;
         AttachedFile.FBodyBin.LoadFromStream( buff );
     finally
         buff.Free;
         DeleteFile( tmpFileName);
         if FDecodeProgress < 100 then FDoDecodeProgress( 100);
         FDoDecodeEnd;
     end;
end;


procedure TSakPOP.UUDecode( var AttachedFile: TAttachedFile);
const Table = '`!"#$%&''()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_';
var
   A45Bytes: array[1..45] of byte;
   A24Bits: array[0..8*45] of boolean;
   i,j,k,b,m, BytesGenerated, step : word;
   ndx : LongInt;
   Txt: TStringList;
   line, tmpFileName: string;
   LineLen, ActualLen : byte;
   buff: TFileStream;

function ByteFromTable(Ch : Char) : byte;
var n: byte;
begin
     n := 1;
     while (Ch<>Table[n]) and (n<=64) do Inc(n);
     if n > 64 then
     begin
          if Ch=' ' then n := 1
                    else raise Exception.Create( FErrorInFormatOfMsg);
     end;
     Result := n-1;
end;

begin
     Txt := AttachedFile.FBodyEncoded;
     FDoDecodeStart( AttachedFile.FileName, Txt.Count);
     step := FDecodeProgressStep;

     tmpFileName := sak_GetTempFileName;

     buff := TFileStream.create( tmpFileName, fmCreate);
     try
        ndx := 1;  { the first line (0) is 'begin 6xx bla bla'}
        repeat
              line := Txt.Strings[ ndx];

              FillChar( A45Bytes, 45, 0);
              FillChar( A24Bits, 8*45+1, 0);
              k:=0;
              LineLen := length( line);
              ActualLen := 4*ByteFromTable( line[1]) div 3;
              if ActualLen <> (4*45 div 3) then ActualLen := LineLen-1;
              for i:=2 to ActualLen+1 do
              begin
                   b:=ByteFromTable( line[i]);
                   for j:=5 DownTo 0 do
                   begin
                        m:=1 shl j;
                        if (b and m = m) then A24Bits[k]:=true;
                        Inc(k);
                   end;
              end;
              k:=0;
              for i:=1 to 45 do
              begin
                   b:=0;
                   for j:=7 DownTo 0 do
                   begin
                        if A24Bits[k] then b:= b or (1 shl j);
                        Inc(k);
                   end;
                   A45Bytes[i] := b;
              end;
              BytesGenerated:=ByteFromTable( line[1]);

              Buff.Write( A45Bytes, BytesGenerated);
              FDecodeProgress := Round(100*ndx/Txt.Count);
              if ( FDecodeProgress >= step) then
              begin
                   FDoDecodeProgress( FDecodeProgress);
                   inc( step, FDecodeProgressStep);
              end;
              Application.ProcessMessages;
              Inc( ndx);
        until (ndx = Txt.Count) or (Txt[ndx] = 'end')
              or (Txt[ndx] = Table[1]);

        buff.Position := 0;
        AttachedFile.FBodyBin.LoadFromStream( buff );
     finally
        buff.Free;
        DeleteFile( tmpFileName);
        if FDecodeProgress < 100 then FDoDecodeProgress( 100);
        FDoDecodeEnd;
     end;
end;

function  TSakPOP.FindUUAttachs( const strList: TStringList;
                                 var line: integer;
                                 var FileName: string): boolean;
var s, que, permiss: string;
    position, intPermiss: integer;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;
     que := 'begin';
     repeat
           s := lowerCase( strList[ line]);
           position := pos( que, s);
           if position = 1 then
              if length( s) > 10 then   { begin 600 n}
              begin
                permiss := copy( s, 7, 3);
                intPermiss := StrToIntDef( permiss, -1);
                if (intPermiss > 0) and (intPermiss < 777) then
                begin
                     FileName := copy( strList[ line], 11, 64);
                     result := true;
                     break;
                end;
              end;
           inc( line);
     until line = strList.count;
end;


function  TSakPOP.FindInHeaders( const que: string; const strList: TStringList;
                                 var line: integer): boolean;
var s: string;
    position: integer;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;                  // the method find of TStringList is useless in this case
     repeat
           s := upperCase( strList[ line]);
           position := pos( que, s);
           if position = 1 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

function  TSakPOP.FindInStringList( const que: string; const strList: TStringList;
                                    var line, position: integer): boolean;
var s: string;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;                  // the method find of TStringList is useless in this case
     repeat
           s := upperCase( strList[ line]);
           position := pos( que, s);
           if position > 0 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

function  TSakPOP.FindInStringListCS( const que: string; const strList: TStringList;
                                      var line, position: integer): boolean;
begin
     result := false;
     if StrList.Count = 0 then exit;
     line := 0;
     repeat
           if pos( que, strList[line]) > 0 then break;
           inc( line);
     until line = strList.count;
     if line <> strList.count then result := true;
end;

procedure TSakPOP.FDoDisconnect( Sender: TObject; Socket: TCustomWinSocket);
begin
     FConnected := false;
     if assigned( FOnDisconnect) then FOnDisconnect( Sender);
end;

function TSakPOP.FReceiveTextFromSocket: string;
var s: string;
    x: integer;
    buff: array[1..1024] of char;
begin
     while not FSocketStream.WaitForData( 200) do Application.ProcessMessages;
     x := FSocketStream.read( buff, 1024);
     s := copy( buff, 1, x);
     FReplyCode := trim( copy( s, 1, 4));
     FReplyString := trim( copy( s, 5, pos( crlf, s) -5));
     FPOPError := FReplyCode = '-ERR';
     result := s;
end;

procedure TSakPOP.FSendTextToSocket( const txt: string);
begin
     FSocketStream.write( pchar( txt)^, length( txt));
end;

procedure TSakPOP.FDoErr( err: integer);
begin
     FDoError( self, FSocket.Socket, eeGeneral, err);
end;

procedure TSakPOP.FDoError( Sender: TObject; Socket: TCustomWinSocket;
                            ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
     FPOPError := true;
     FMessagesDeleted.Clear;
     FMessagesDeleted.free;
     FSocketStream.Free;
     FSocket.close;
     FConnected := false;
     if assigned( FOnError) then FOnError( Sender, ErrorCode, FReplyString);
end;

procedure TSakPOP.FDoDecodeStart( FileName: string; BytesCount: longint);
begin
     if assigned( FOnDecodeStart) then FOnDecodeStart( self, FileName, BytesCount);
end;

procedure TSakPOP.FDoDecodeProgress( Percent: word);
begin
     if assigned( FOnDecodeProgress) then FOnDecodeProgress( self, Percent);
end;

procedure TSakPOP.FDoDecodeEnd;
begin
     if assigned( FOnDecodeEnd) then FOnDecodeEnd( self);
end;

procedure TSakPOP.FDoBeforeRetrieve( id: word);
begin
     if assigned( FOnBeforeRetrieve) then FOnBeforeRetrieve( self, id);
end;

procedure TSakPOP.FDoAfterRetrieve;
begin
     if assigned( FOnAfterRetrieve) then FOnAfterRetrieve( self);
end;

procedure TSakPOP.FDoRetrieveProgress( Percent: word);
begin
     if assigned( FOnRetrieveProgress) then FOnRetrieveProgress( self, Percent);
end;

procedure TSakPOP.FDoDelete( id: word);
begin
     if assigned( FOnDelete) then FOnDelete( self, id);
end;

end.
